'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AsyncResolver = undefined;

var _createClass = function () {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) descriptor.writable = true;
            Object.defineProperty(target, descriptor.key, descriptor);
        }
    }

    return function (Constructor, protoProps, staticProps) {
        if (protoProps) defineProperties(Constructor.prototype, protoProps);
        if (staticProps) defineProperties(Constructor, staticProps);
        return Constructor;
    };
}();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _helpers = require('./helpers');

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}

function _possibleConstructorReturn(self, call) {
    if (!self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return call && (typeof call === "object" || typeof call === "function") ? call : self;
}

function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            enumerable: false,
            writable: true,
            configurable: true
        }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
}

var object = _react.PropTypes.object;
var func = _react.PropTypes.func;

var AsyncResolver = exports.AsyncResolver = function (_Component) {
    _inherits(AsyncResolver, _Component);

    function AsyncResolver() {
        _classCallCheck(this, AsyncResolver);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(AsyncResolver).apply(this, arguments));
    }

    _createClass(AsyncResolver, [{
        key: 'listenToHistory',
        value: function listenToHistory() {
            var _this2 = this;

            if (this.state) return;

            var unlisten = this.history.listenBefore(function (location, continueTransiton) {
                (0, _reactRouter.match)({
                    history: history,
                    location: location,
                    routes: routes
                }, function (error, redirectLocation, renderProps) {
                    //TODO handle redirect
                    if (redirectLocation) {
                        history.transitionTo(redirectLocation);
                    } else if (renderProps) {
                        var components = renderProps.components;
                        var params = renderProps.params;

                        var attrs = [location, params, _this2.props.custom];
                        Promise.all((0, _helpers.getPreResolveDependencies)(components).apply(undefined, attrs)).then(continueTransiton, continueTransiton).then((0, _helpers.getDeferResolveDependencies)(components).apply(undefined, attrs));
                    }
                });
            });

            this.setState(unlisten);
        }
    }, {
        key: 'stopListeningToHistory',
        value: function stopListeningToHistory() {
            if (this.state) {
                this.state();
            }
            this.setState(undefined);
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.listenToHistory();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.stopListeningToHistory();
        }
    }, {
        key: 'render',
        value: function render() {
            return this.props.router(this.props);
        }
    }]);

    return AsyncResolver;
}(_react.Component);

AsyncResolver.propTypes = {
    history: object.isRequired,
    routes: object.isRequired,
    router: func,
    onError: func,
    onNotFound: func
};
AsyncResolver.defaultProps = {
    router: function router(_ref) {
        var history = _ref.history;
        var routes = _ref.routes;
        return _react2.default.createElement(_reactRouter.ReactRouter, {history: history, routes: routes});
    },
    onError: function onError(err) {
        return console.log('Error in async resolving', err);
    },
    onNotFound: function onNotFound() {
        return console.log('No route matched');
    }
};
AsyncResolver.state = undefined;