'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var getDependencies = function getDependencies(components) {
  var preResolve = arguments.length <= 1 || arguments[1] === undefined ? true : arguments[1];
  return function (attrs) {
    var resolveType = preResolve ? 'preResolve' : 'deferResolve';
    return components.filter(function (component) {
      return component && component[resolveType];
    }).map(function (component) {
      return component[resolveType];
    }).map(function (fetchData) {
      return fetchData(attrs);
    });
  };
};

var getPreResolveDependencies = exports.getPreResolveDependencies = function getPreResolveDependencies(components) {
  return getDependencies(components, true);
};
var getDeferResolveDependencies = exports.getDeferResolveDependencies = function getDeferResolveDependencies(components) {
  return getDependencies(components, false);
};